> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/release-orchestration/api-reference/releases-beta.md).

# Releases \[Beta]

## Create Ad Hoc Release

> Create an ad hoc release with a linked orchestration process, bypassing the standard release group cadence.

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/adhoc":{"post":{"description":"Create an ad hoc release with a linked orchestration process, bypassing the standard release group cadence.","operationId":"PostReleaseAdhoc","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"}],"requestBody":{"$ref":"#/components/requestBodies/CreateAdHocReleaseRequest"},"responses":{"201":{"$ref":"#/components/responses/CreateAdHocReleaseResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"409":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Create Ad Hoc Release","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}}},"requestBodies":{"CreateAdHocReleaseRequest":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AdHocReleaseRequest"}}},"description":"Request body for creating an ad hoc release","required":true}},"schemas":{"AdHocReleaseRequest":{"properties":{"color":{"description":"Hex color code for the release","type":"string"},"description":{"description":"Optional description","type":"string"},"expectedEndTs":{"description":"Expected end timestamp in milliseconds","type":"integer"},"expectedStartTs":{"description":"Expected start timestamp in milliseconds","type":"integer"},"identifier":{"description":"Unique identifier for the ad hoc release","type":"string"},"name":{"description":"Name of the ad hoc release","type":"string"},"processGitBranch":{"description":"Git branch used to read the orchestration process definition for this release. Required when the process is stored in Git.","type":"string"},"processIdentifier":{"description":"Identifier of the orchestration process","type":"string"},"processInputIdentifier":{"description":"Identifier of the orchestration process input (optional)","type":"string"},"tags":{"additionalProperties":{"type":"string"},"description":"Key-value tags for the release","type":"object"},"version":{"description":"Version of the ad hoc release","type":"string"}},"required":["processIdentifier","name","version","identifier","expectedStartTs","expectedEndTs"],"title":"AdHocReleaseRequest","type":"object"},"AdHocReleaseResponse":{"properties":{"id":{"description":"ID of the created release","type":"string"},"identifier":{"description":"Identifier of the created release","type":"string"}},"required":["id","identifier"],"title":"AdHocReleaseResponse","type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}},"responses":{"CreateAdHocReleaseResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AdHocReleaseResponse"}}},"description":"Ad hoc release created successfully"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}}}}
```

## Fetch Release Activities Day Wise

> Fetch a list of activities based on the startTime, endTime and release Id for a day view

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/calendar/{releaseId}/activities":{"get":{"description":"Fetch a list of activities based on the startTime, endTime and release Id for a day view","operationId":"GetReleaseDayActivities","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"},{"$ref":"#/components/parameters/ReleaseId"},{"$ref":"#/components/parameters/StartTime"},{"$ref":"#/components/parameters/EndTime"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Cursor"}],"responses":{"200":{"$ref":"#/components/responses/ReleaseActivitiesResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Fetch Release Activities Day Wise","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}},"ReleaseId":{"in":"path","name":"releaseId","required":true,"schema":{"type":"string"}},"StartTime":{"in":"query","name":"startTs","required":true,"schema":{"type":"integer"}},"EndTime":{"in":"query","name":"endTs","required":true,"schema":{"type":"integer"}},"Limit":{"description":"The number of records expected","in":"query","name":"limit","schema":{"default":500,"maximum":500,"type":"number"}},"Cursor":{"description":"Cursor Based Pagination","in":"query","name":"cursor","schema":{"type":"string"}}},"responses":{"ReleaseActivitiesResponse":{"content":{"application/json":{"schema":{"properties":{"activities":{"description":"List of activities.","items":{"$ref":"#/components/schemas/ReleaseActivity"},"type":"array"},"last":{"type":"boolean"},"nextRequest":{"$ref":"#/components/schemas/NextRequest"}},"required":["activities","nextRequest","last"],"type":"object"}}},"description":"Successful response"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"ReleaseActivity":{"properties":{"accountId":{"description":"Account identifier.","type":"string"},"id":{"description":"Unique identifier for the activity.","type":"string"},"orgIdentifier":{"description":"Organization identifier.","type":"string"},"pipelineIdentifier":{"description":"Pipeline identifier.","type":"string"},"pipelineName":{"description":"Name of the pipeline.","type":"string"},"planExecutionId":{"description":"Plan execution identifier.","type":"string"},"projectIdentifier":{"description":"Project identifier.","type":"string"},"stageInfo":{"$ref":"#/components/schemas/StageInfoDTO"},"stepInfo":{"$ref":"#/components/schemas/StepInfoDTO"},"triggeredBy":{"$ref":"#/components/schemas/TriggeredByDTO"},"type":{"$ref":"#/components/schemas/ActivityType"}},"required":["id","planExecutionId","accountId","orgIdentifier","projectIdentifier","pipelineIdentifier","pipelineName","type","triggeredBy"],"type":"object"},"StageInfoDTO":{"description":"Details about the stage activity (provided if type is stage).","properties":{"endTs":{"description":"End timestamp of the stage.","type":"integer"},"identifier":{"description":"Identifier of the stage.","type":"string"},"info":{"$ref":"#/components/schemas/StageInfoDetailsDTO"},"name":{"description":"Name of the stage.","type":"string"},"stageExecutionId":{"description":"Stage execution Id.","type":"string"},"stageNodeId":{"description":"Node Id of the stage.","type":"string"},"startTs":{"description":"Start timestamp of the stage.","type":"integer"},"status":{"$ref":"#/components/schemas/Status"},"type":{"$ref":"#/components/schemas/StageInfoType"}},"required":["type","name","identifier","status","startTs","info"],"type":"object"},"StageInfoDetailsDTO":{"description":"Info related to stage","properties":{"artifactDisplayName":{"description":"Display name of the artifact.","type":"string"},"envId":{"description":"Identifier of the environment.","type":"string"},"envName":{"description":"Name of the environment.","type":"string"},"serviceId":{"description":"Identifier of the service.","type":"string"},"serviceName":{"description":"Name of the service.","type":"string"}},"type":"object"},"Status":{"description":"Status of the stage.","enum":["ABORTED","OUTPUT_WAITING","ASYNC_WAITING","APPROVAL_REJECTED","APPROVAL_WAITING","DISCONTINUING","ERROR","ERRORED","EXPIRED","FAILED","FREEZE_FAILED","IGNORE_FAILED","INPUT_WAITING","INTERVENTION_WAITING","QUEUED","REJECTED","RESUMED","RUNNING","SCHEDULED","SKIPPED","STARTING","STARTING_QUEUED_STEP","SUCCESS","SUCCEEDED","SUSPENDED","TIMED_WAITING","TASK_WAITING","UPLOAD_WAITING","WAIT_STEP_RUNNING","WAITING","ON_HOLD"],"type":"string"},"StageInfoType":{"description":"Type of the stage (e.g., CD, custom)","enum":["CD","Custom","GITOPS","Approval"],"type":"string"},"StepInfoDTO":{"description":"Details about the step activity (provided if type is step).","properties":{"endTs":{"description":"End timestamp of the step.","type":"integer"},"identifier":{"description":"Identifier of the step.","type":"string"},"info":{"$ref":"#/components/schemas/StepInfoDetailsDTO"},"name":{"description":"Name of the step.","type":"string"},"stageExecutionId":{"description":"Stage Execution Id","type":"string"},"stageNodeId":{"description":"Node Id of the stage.","type":"string"},"startTs":{"description":"Start timestamp of the step.","type":"integer"},"status":{"$ref":"#/components/schemas/Status"},"stepExecutionId":{"description":"Step execution identifier.","type":"string"},"type":{"$ref":"#/components/schemas/StepInfoType"}},"required":["type","name","identifier","status","startTs","info"],"type":"object"},"StepInfoDetailsDTO":{"description":"Provided if `type` is Approval.","properties":{"approvalAction":{"description":"Action taken for the approval.","type":"string"},"approvedAt":{"description":"Timestamp of the approval.","format":"integer","type":"integer"},"approvedByEmail":{"description":"Email of the person who approved the step.","type":"string"},"approvedByName":{"description":"Name of the person who approved the step.","type":"string"},"comments":{"description":"Comments provided during the approval.","type":"string"},"issueType":{"description":"Type of the Jira issue.","type":"string"},"jiraUrl":{"description":"URL of the Jira ticket.","type":"string"},"ticketStatus":{"description":"Status of the Jira ticket.","type":"string"}},"type":"object"},"StepInfoType":{"description":"Type of the step (e.g., Approval, JiraUpdate, JiraCreate, JiraApproval).","enum":["HarnessApproval","JiraUpdate","JiraCreate","JiraApproval","ServiceNowApproval","CustomApproval"],"type":"string"},"TriggeredByDTO":{"description":"Details of the user who triggered the activity.","properties":{"avatar":{"description":"Avatar URL of the person.","type":"string"},"email":{"description":"Email of the person who triggered the activity.","type":"string"},"id":{"description":"Identifier of the person who triggered the activity.","type":"string"},"name":{"description":"Name of the person who triggered the activity.","type":"string"},"triggerType":{"$ref":"#/components/schemas/TriggerType"}},"type":"object"},"TriggerType":{"description":"Unit of time used for repeating releases.","enum":["MANUAL","WEBHOOK","WEBHOOK_CUSTOM","ARTIFACT","MANIFEST","SCHEDULER_CRON"],"type":"string"},"ActivityType":{"description":"Type of the activity (e.g., stage, step).","enum":["stage","step"],"type":"string"},"NextRequest":{"properties":{"cursor":{"type":"string"},"limit":{"type":"integer"}},"type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## List Releases with Pagination

> Fetch paginated list of releases with sorting support. Uses standard page/size pagination instead of cursor-based.

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/list":{"post":{"description":"Fetch paginated list of releases with sorting support. Uses standard page/size pagination instead of cursor-based.","operationId":"PostReleaseList","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/Page"},{"$ref":"#/components/parameters/Size"},{"$ref":"#/components/parameters/Sort"},{"description":"Expected start time in milliseconds (Unix timestamp)","in":"query","name":"expectedStartTs","required":true,"schema":{"type":"integer"}},{"description":"Expected end time in milliseconds (Unix timestamp)","in":"query","name":"expectedEndTs","required":true,"schema":{"type":"integer"}},{"$ref":"#/components/parameters/SearchTermParam"},{"$ref":"#/components/parameters/ReleaseGroupIdsParam"},{"$ref":"#/components/parameters/ReleaseTypeParam"},{"$ref":"#/components/parameters/ReleaseSourceParam"},{"$ref":"#/components/parameters/ReleaseStatusListParam"}],"requestBody":{"$ref":"#/components/requestBodies/ReleaseListRequest"},"responses":{"200":{"$ref":"#/components/responses/ReleaseListResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"List Releases with Pagination","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"Page":{"in":"query","name":"page","schema":{"type":"integer"}},"Size":{"in":"query","name":"size","schema":{"type":"integer"}},"Sort":{"description":"Sort parameters as an array. Format: `[field_name, direction]` where direction is `asc` or `desc`.\nSupported fields: `start_ts`, `startTs`, `end_ts`, `endTs`, `last_updated_at`, `lastUpdatedAt`, `created_at`, `createdAt`, `name`, `identifier`, `status`, `type`.\nWhen used in query params, use format: `sort=field_name&sort=direction` (e.g., `sort=start_ts&sort=desc`).\n","in":"query","name":"sort","schema":{"items":{"type":"string"},"type":"array"}},"SearchTermParam":{"description":"Optional search string to filter releases by name.","in":"query","name":"searchTerm","schema":{"type":"string"}},"ReleaseGroupIdsParam":{"description":"Optional list of release group IDs to filter by","in":"query","name":"releaseGroupIds","schema":{"items":{"type":"string"},"type":"array"}},"ReleaseTypeParam":{"description":"Optional release type filter (Orchestration or Tracking)","in":"query","name":"type","schema":{"enum":["Orchestration","Tracking"],"type":"string"}},"ReleaseSourceParam":{"description":"Optional release source filter (ADHOC or RECURRING)","in":"query","name":"source","schema":{"enum":["ADHOC","RECURRING"],"type":"string"}},"ReleaseStatusListParam":{"description":"Optional filter by release status (can specify multiple statuses)","in":"query","name":"status","schema":{"items":{"enum":["Running","Success","Failed","Scheduled","Paused","Aborted","InputWaiting"],"type":"string"},"type":"array","uniqueItems":true}}},"requestBodies":{"ReleaseListRequest":{"content":{"application/json":{"schema":{"properties":{"scopes":{"description":"Optional array of scope filters for hierarchical filtering (account/org/project levels)","items":{"$ref":"#/components/schemas/ScopeFilterDTO"},"type":"array"}},"type":"object"}}},"description":"Request body for paginated release list","required":true}},"schemas":{"ScopeFilterDTO":{"description":"Hierarchical scope filter for account/org/project levels","properties":{"orgIdentifier":{"description":"Optional organization identifier. If omitted, filters at account level.","type":"string"},"projectIdentifier":{"description":"Optional project identifier. If omitted (with org present), filters at org level.","type":"string"}},"title":"ScopeFilterDTO","type":"object"},"ReleaseDTO":{"properties":{"actualEndTs":{"description":"Actual end timestamp in milliseconds","type":"integer"},"actualStartTs":{"description":"Actual start timestamp in milliseconds","type":"integer"},"color":{"description":"Hex color code representing the release","type":"string"},"createdAt":{"description":"Created timestamp in milliseconds","type":"integer"},"createdBy":{"$ref":"#/components/schemas/CreatedByDTO"},"expectedEndTs":{"description":"Expected end timestamp in milliseconds","type":"integer"},"expectedStartTs":{"description":"Expected start timestamp in milliseconds","type":"integer"},"hasConflict":{"description":"Whether the release has a conflict","type":"boolean"},"id":{"description":"Unique identifier for the release","type":"string"},"identifier":{"description":"Identifier for the release","type":"string"},"lastUpdatedAt":{"description":"Last updated timestamp in milliseconds","type":"integer"},"lastUpdatedBy":{"$ref":"#/components/schemas/LastUpdatedByDTO"},"name":{"description":"Name of the release","type":"string"},"processGitBranch":{"description":"Git branch used to read the orchestration process definition for this release. Set when the release is created and cannot be changed afterwards.","type":"string"},"processIdentifier":{"description":"Identifier for the orchestration process.","type":"string"},"processInputIdentifier":{"description":"Identifier for the orchestration process input.","type":"string"},"releaseGroupId":{"description":"Identifier for the release group","type":"string"},"source":{"description":"Source of the release (ADHOC for ad hoc releases, RECURRING for scheduled releases)","enum":["ADHOC","RECURRING"],"type":"string"},"status":{"description":"Current status of the release","enum":["Running","Success","Failed","Scheduled","Paused","Aborted","InputWaiting"],"type":"string"},"triggeredBy":{"$ref":"#/components/schemas/TriggeredByDTO"},"version":{"description":"Version of the release","type":"string"}},"required":["id","identifier","name","status","expectedStartTs","expectedEndTs","releaseGroupId","color","version"],"title":"ReleaseDTO","type":"object"},"CreatedByDTO":{"description":"Details of the user who created the event","properties":{"email":{"description":"Email of the user who created the event","type":"string"},"identifier":{"description":"Identifier of the user who created the event","type":"string"},"name":{"description":"Name of the user who created the event","type":"string"}},"required":["name","email"],"type":"object"},"LastUpdatedByDTO":{"properties":{"email":{"type":"string"},"identifier":{"type":"string"},"name":{"type":"string"}},"required":["identifier"],"title":"LastUpdatedByDTO","type":"object"},"TriggeredByDTO":{"description":"Details of the user who triggered the activity.","properties":{"avatar":{"description":"Avatar URL of the person.","type":"string"},"email":{"description":"Email of the person who triggered the activity.","type":"string"},"id":{"description":"Identifier of the person who triggered the activity.","type":"string"},"name":{"description":"Name of the person who triggered the activity.","type":"string"},"triggerType":{"$ref":"#/components/schemas/TriggerType"}},"type":"object"},"TriggerType":{"description":"Unit of time used for repeating releases.","enum":["MANUAL","WEBHOOK","WEBHOOK_CUSTOM","ARTIFACT","MANIFEST","SCHEDULER_CRON"],"type":"string"},"Pageable":{"properties":{"offset":{"type":"integer"},"pageNumber":{"type":"integer"},"pageSize":{"type":"integer"},"paged":{"type":"boolean"},"sort":{"$ref":"#/components/schemas/PageableSort"},"unpaged":{"type":"boolean"}},"type":"object"},"PageableSort":{"properties":{"empty":{"type":"boolean"},"sorted":{"type":"boolean"},"unsorted":{"type":"boolean"}},"type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}},"responses":{"ReleaseListResponse":{"content":{"application/json":{"schema":{"properties":{"content":{"items":{"$ref":"#/components/schemas/ReleaseDTO"},"type":"array"},"empty":{"description":"Whether the page is empty","type":"boolean"},"first":{"description":"Whether this is the first page","type":"boolean"},"last":{"description":"Whether this is the last page","type":"boolean"},"number":{"description":"Current page number (zero-indexed)","type":"integer"},"numberOfElements":{"description":"Number of elements in current page","type":"integer"},"pageable":{"$ref":"#/components/schemas/Pageable"},"size":{"description":"Page size","type":"integer"},"sort":{"$ref":"#/components/schemas/PageableSort"},"totalElements":{"description":"Total number of releases","format":"int64","type":"integer"},"totalPages":{"description":"Total number of pages","type":"integer"}},"required":["content","pageable","totalPages","last","totalElements","size","number","sort","numberOfElements","first","empty"],"type":"object"}}},"description":"Paginated list of releases"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}}}}
```

## Fetch Release Summary

> Fetch a list of releases based on the specified time ranges, optional filters, and search query.

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/summary":{"post":{"description":"Fetch a list of releases based on the specified time ranges, optional filters, and search query.","operationId":"PostReleaseSummary","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/SearchTermParam"},{"$ref":"#/components/parameters/ReleaseGroupIdsParam"},{"$ref":"#/components/parameters/ReleaseTypeParam"},{"$ref":"#/components/parameters/ReleaseSourceParam"},{"$ref":"#/components/parameters/ReleaseStatusListParam"}],"requestBody":{"$ref":"#/components/requestBodies/ReleaseSummaryRequest"},"responses":{"200":{"$ref":"#/components/responses/ReleaseSummaryResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Fetch Release Summary","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"SearchTermParam":{"description":"Optional search string to filter releases by name.","in":"query","name":"searchTerm","schema":{"type":"string"}},"ReleaseGroupIdsParam":{"description":"Optional list of release group IDs to filter by","in":"query","name":"releaseGroupIds","schema":{"items":{"type":"string"},"type":"array"}},"ReleaseTypeParam":{"description":"Optional release type filter (Orchestration or Tracking)","in":"query","name":"type","schema":{"enum":["Orchestration","Tracking"],"type":"string"}},"ReleaseSourceParam":{"description":"Optional release source filter (ADHOC or RECURRING)","in":"query","name":"source","schema":{"enum":["ADHOC","RECURRING"],"type":"string"}},"ReleaseStatusListParam":{"description":"Optional filter by release status (can specify multiple statuses)","in":"query","name":"status","schema":{"items":{"enum":["Running","Success","Failed","Scheduled","Paused","Aborted","InputWaiting"],"type":"string"},"type":"array","uniqueItems":true}}},"requestBodies":{"ReleaseSummaryRequest":{"content":{"application/json":{"schema":{"properties":{"scopes":{"description":"Optional array of scope filters for hierarchical filtering (account/org/project levels)","items":{"$ref":"#/components/schemas/ScopeFilterDTO"},"type":"array"},"timeRanges":{"items":{"$ref":"#/components/schemas/TimeRangeDTO"},"type":"array"}},"type":"object"}}},"description":"Provide the filtering for release summary","required":true}},"schemas":{"ScopeFilterDTO":{"description":"Hierarchical scope filter for account/org/project levels","properties":{"orgIdentifier":{"description":"Optional organization identifier. If omitted, filters at account level.","type":"string"},"projectIdentifier":{"description":"Optional project identifier. If omitted (with org present), filters at org level.","type":"string"}},"title":"ScopeFilterDTO","type":"object"},"TimeRangeDTO":{"properties":{"cursor":{"type":"string"},"endTime":{"type":"integer"},"limit":{"type":"integer"},"startTime":{"type":"integer"}},"required":["startTime","endTime"],"title":"TimeRangeDTO","type":"object"},"ReleaseDTO":{"properties":{"actualEndTs":{"description":"Actual end timestamp in milliseconds","type":"integer"},"actualStartTs":{"description":"Actual start timestamp in milliseconds","type":"integer"},"color":{"description":"Hex color code representing the release","type":"string"},"createdAt":{"description":"Created timestamp in milliseconds","type":"integer"},"createdBy":{"$ref":"#/components/schemas/CreatedByDTO"},"expectedEndTs":{"description":"Expected end timestamp in milliseconds","type":"integer"},"expectedStartTs":{"description":"Expected start timestamp in milliseconds","type":"integer"},"hasConflict":{"description":"Whether the release has a conflict","type":"boolean"},"id":{"description":"Unique identifier for the release","type":"string"},"identifier":{"description":"Identifier for the release","type":"string"},"lastUpdatedAt":{"description":"Last updated timestamp in milliseconds","type":"integer"},"lastUpdatedBy":{"$ref":"#/components/schemas/LastUpdatedByDTO"},"name":{"description":"Name of the release","type":"string"},"processGitBranch":{"description":"Git branch used to read the orchestration process definition for this release. Set when the release is created and cannot be changed afterwards.","type":"string"},"processIdentifier":{"description":"Identifier for the orchestration process.","type":"string"},"processInputIdentifier":{"description":"Identifier for the orchestration process input.","type":"string"},"releaseGroupId":{"description":"Identifier for the release group","type":"string"},"source":{"description":"Source of the release (ADHOC for ad hoc releases, RECURRING for scheduled releases)","enum":["ADHOC","RECURRING"],"type":"string"},"status":{"description":"Current status of the release","enum":["Running","Success","Failed","Scheduled","Paused","Aborted","InputWaiting"],"type":"string"},"triggeredBy":{"$ref":"#/components/schemas/TriggeredByDTO"},"version":{"description":"Version of the release","type":"string"}},"required":["id","identifier","name","status","expectedStartTs","expectedEndTs","releaseGroupId","color","version"],"title":"ReleaseDTO","type":"object"},"CreatedByDTO":{"description":"Details of the user who created the event","properties":{"email":{"description":"Email of the user who created the event","type":"string"},"identifier":{"description":"Identifier of the user who created the event","type":"string"},"name":{"description":"Name of the user who created the event","type":"string"}},"required":["name","email"],"type":"object"},"LastUpdatedByDTO":{"properties":{"email":{"type":"string"},"identifier":{"type":"string"},"name":{"type":"string"}},"required":["identifier"],"title":"LastUpdatedByDTO","type":"object"},"TriggeredByDTO":{"description":"Details of the user who triggered the activity.","properties":{"avatar":{"description":"Avatar URL of the person.","type":"string"},"email":{"description":"Email of the person who triggered the activity.","type":"string"},"id":{"description":"Identifier of the person who triggered the activity.","type":"string"},"name":{"description":"Name of the person who triggered the activity.","type":"string"},"triggerType":{"$ref":"#/components/schemas/TriggerType"}},"type":"object"},"TriggerType":{"description":"Unit of time used for repeating releases.","enum":["MANUAL","WEBHOOK","WEBHOOK_CUSTOM","ARTIFACT","MANIFEST","SCHEDULER_CRON"],"type":"string"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}},"responses":{"ReleaseSummaryResponse":{"content":{"application/json":{"schema":{"properties":{"last":{"type":"boolean"},"nextRequest":{"items":{"$ref":"#/components/schemas/TimeRangeDTO"},"type":"array"},"releases":{"items":{"$ref":"#/components/schemas/ReleaseDTO"},"type":"array"}},"required":["releases","nextRequest"],"type":"object"}}},"description":"Returns a list of releaseEntities"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}}}}
```

## Fetch Release Information

> Gets the release information for a given release

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}":{"get":{"description":"Gets the release information for a given release","operationId":"GetRelease","parameters":[{"$ref":"#/components/parameters/AccountParam"}],"responses":{"200":{"$ref":"#/components/responses/ReleaseDetailsResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Fetch Release Information","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}}},"responses":{"ReleaseDetailsResponse":{"content":{"application/json":{"schema":{"properties":{"parentReleases":{"description":"Ancestor releases for this release, starting from the immediate parent up to 3 levels.","items":{"$ref":"#/components/schemas/ReleaseParentDTO"},"type":"array"},"releaseInfo":{"$ref":"#/components/schemas/ReleaseDTO"},"yaml":{"type":"string"}},"required":["releaseInfo","yaml"],"type":"object"}}},"description":"Response for the single release information"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"ReleaseParentDTO":{"properties":{"activityIdentifier":{"description":"Identifier of the subprocess activity that created this ancestor release (empty for roots)","type":"string"},"activityName":{"description":"Name of the subprocess activity that created this ancestor release (empty for roots)","type":"string"},"id":{"description":"Release id of the ancestor","type":"string"},"identifier":{"description":"Release identifier of the ancestor","type":"string"},"processIdentifier":{"description":"Identifier of the orchestration process attached to this ancestor release","type":"string"},"processName":{"description":"Name of the orchestration process attached to this ancestor release","type":"string"}},"title":"ReleaseParentDTO","type":"object"},"ReleaseDTO":{"properties":{"actualEndTs":{"description":"Actual end timestamp in milliseconds","type":"integer"},"actualStartTs":{"description":"Actual start timestamp in milliseconds","type":"integer"},"color":{"description":"Hex color code representing the release","type":"string"},"createdAt":{"description":"Created timestamp in milliseconds","type":"integer"},"createdBy":{"$ref":"#/components/schemas/CreatedByDTO"},"expectedEndTs":{"description":"Expected end timestamp in milliseconds","type":"integer"},"expectedStartTs":{"description":"Expected start timestamp in milliseconds","type":"integer"},"hasConflict":{"description":"Whether the release has a conflict","type":"boolean"},"id":{"description":"Unique identifier for the release","type":"string"},"identifier":{"description":"Identifier for the release","type":"string"},"lastUpdatedAt":{"description":"Last updated timestamp in milliseconds","type":"integer"},"lastUpdatedBy":{"$ref":"#/components/schemas/LastUpdatedByDTO"},"name":{"description":"Name of the release","type":"string"},"processGitBranch":{"description":"Git branch used to read the orchestration process definition for this release. Set when the release is created and cannot be changed afterwards.","type":"string"},"processIdentifier":{"description":"Identifier for the orchestration process.","type":"string"},"processInputIdentifier":{"description":"Identifier for the orchestration process input.","type":"string"},"releaseGroupId":{"description":"Identifier for the release group","type":"string"},"source":{"description":"Source of the release (ADHOC for ad hoc releases, RECURRING for scheduled releases)","enum":["ADHOC","RECURRING"],"type":"string"},"status":{"description":"Current status of the release","enum":["Running","Success","Failed","Scheduled","Paused","Aborted","InputWaiting"],"type":"string"},"triggeredBy":{"$ref":"#/components/schemas/TriggeredByDTO"},"version":{"description":"Version of the release","type":"string"}},"required":["id","identifier","name","status","expectedStartTs","expectedEndTs","releaseGroupId","color","version"],"title":"ReleaseDTO","type":"object"},"CreatedByDTO":{"description":"Details of the user who created the event","properties":{"email":{"description":"Email of the user who created the event","type":"string"},"identifier":{"description":"Identifier of the user who created the event","type":"string"},"name":{"description":"Name of the user who created the event","type":"string"}},"required":["name","email"],"type":"object"},"LastUpdatedByDTO":{"properties":{"email":{"type":"string"},"identifier":{"type":"string"},"name":{"type":"string"}},"required":["identifier"],"title":"LastUpdatedByDTO","type":"object"},"TriggeredByDTO":{"description":"Details of the user who triggered the activity.","properties":{"avatar":{"description":"Avatar URL of the person.","type":"string"},"email":{"description":"Email of the person who triggered the activity.","type":"string"},"id":{"description":"Identifier of the person who triggered the activity.","type":"string"},"name":{"description":"Name of the person who triggered the activity.","type":"string"},"triggerType":{"$ref":"#/components/schemas/TriggerType"}},"type":"object"},"TriggerType":{"description":"Unit of time used for repeating releases.","enum":["MANUAL","WEBHOOK","WEBHOOK_CUSTOM","ARTIFACT","MANIFEST","SCHEDULER_CRON"],"type":"string"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## PUT /release/{releaseId}

> Update a single release

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}":{"put":{"operationId":"PutReleaseReleaseId","parameters":[{"$ref":"#/components/parameters/AccountParam"}],"requestBody":{"$ref":"#/components/requestBodies/UpdateReleaseRequest"},"responses":{"200":{"$ref":"#/components/responses/UpdateReleaseResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Update a single release","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}}},"requestBodies":{"UpdateReleaseRequest":{"content":{"application/json":{"schema":{"properties":{"duration":{"type":"string"},"processIdentifier":{"description":"Identifier of the orchestration process","type":"string"},"processInputIdentifier":{"description":"Identifier of the orchestration process input","type":"string"},"startTs":{"type":"integer"},"yaml":{"type":"string"}},"required":["yaml","startTs","duration"],"type":"object"}}}}},"responses":{"UpdateReleaseResponse":{"content":{"application/json":{"schema":{"properties":{"id":{"type":"string"},"yaml":{"type":"string"}},"required":["id","yaml"],"type":"object"}}},"description":"Response for updating releases"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## Delete Release

> Delete a release. For ADHOC releases, deletes both the release and its stub release group. For RECURRING releases, deletes only the release. The identifier can be either the slug\_id or UUID of the release. Only releases in Scheduled or InputWaiting state can be deleted. Cannot delete releases in Running or Paused states.

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}":{"delete":{"description":"Delete a release. For ADHOC releases, deletes both the release and its stub release group. For RECURRING releases, deletes only the release. The identifier can be either the slug_id or UUID of the release. Only releases in Scheduled or InputWaiting state can be deleted. Cannot delete releases in Running or Paused states.","operationId":"DeleteRelease","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"}],"responses":{"204":{"description":"Release deleted successfully"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Delete Release","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}}},"responses":{"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## Execute Action on Release

> Executes an action on a release (e.g., abort)

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}/action":{"post":{"description":"Executes an action on a release (e.g., abort)","operationId":"PostReleaseAction","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ReleaseActionRequest"}}},"required":true},"responses":{"200":{"$ref":"#/components/responses/ReleaseActionResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Execute Action on Release","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}}},"schemas":{"ReleaseActionRequest":{"properties":{"action":{"description":"Action to perform on the release","enum":["Abort"],"type":"string"},"message":{"description":"Message explaining the reason for the action (e.g., why the release is being aborted)","type":"string"}},"required":["action","message"],"title":"ReleaseActionRequest","type":"object"},"ReleaseActionResponse":{"properties":{"id":{"description":"ID of the release","type":"string"},"interruptedExecutionId":{"description":"ID of the execution that was interrupted","type":"string"},"status":{"description":"New status of the release","type":"string"}},"required":["id","status"],"type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}},"responses":{"ReleaseActionResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ReleaseActionResponse"}}},"description":"Release action executed successfully"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}}}}
```

## Fetch Release Activities

> Fetch a list of activities based on the startTime, endTime and release Id.

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}/activities":{"get":{"description":"Fetch a list of activities based on the startTime, endTime and release Id.","operationId":"GetReleaseActivities","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"},{"$ref":"#/components/parameters/ReleaseId"},{"$ref":"#/components/parameters/StartTime"},{"$ref":"#/components/parameters/EndTime"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Cursor"},{"$ref":"#/components/parameters/StatusListParam"}],"responses":{"200":{"$ref":"#/components/responses/ReleaseActivitiesResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Fetch Release Activities","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}},"ReleaseId":{"in":"path","name":"releaseId","required":true,"schema":{"type":"string"}},"StartTime":{"in":"query","name":"startTs","required":true,"schema":{"type":"integer"}},"EndTime":{"in":"query","name":"endTs","required":true,"schema":{"type":"integer"}},"Limit":{"description":"The number of records expected","in":"query","name":"limit","schema":{"default":500,"maximum":500,"type":"number"}},"Cursor":{"description":"Cursor Based Pagination","in":"query","name":"cursor","schema":{"type":"string"}},"StatusListParam":{"in":"query","name":"status","schema":{"items":{"type":"string"},"type":"array"}}},"responses":{"ReleaseActivitiesResponse":{"content":{"application/json":{"schema":{"properties":{"activities":{"description":"List of activities.","items":{"$ref":"#/components/schemas/ReleaseActivity"},"type":"array"},"last":{"type":"boolean"},"nextRequest":{"$ref":"#/components/schemas/NextRequest"}},"required":["activities","nextRequest","last"],"type":"object"}}},"description":"Successful response"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"ReleaseActivity":{"properties":{"accountId":{"description":"Account identifier.","type":"string"},"id":{"description":"Unique identifier for the activity.","type":"string"},"orgIdentifier":{"description":"Organization identifier.","type":"string"},"pipelineIdentifier":{"description":"Pipeline identifier.","type":"string"},"pipelineName":{"description":"Name of the pipeline.","type":"string"},"planExecutionId":{"description":"Plan execution identifier.","type":"string"},"projectIdentifier":{"description":"Project identifier.","type":"string"},"stageInfo":{"$ref":"#/components/schemas/StageInfoDTO"},"stepInfo":{"$ref":"#/components/schemas/StepInfoDTO"},"triggeredBy":{"$ref":"#/components/schemas/TriggeredByDTO"},"type":{"$ref":"#/components/schemas/ActivityType"}},"required":["id","planExecutionId","accountId","orgIdentifier","projectIdentifier","pipelineIdentifier","pipelineName","type","triggeredBy"],"type":"object"},"StageInfoDTO":{"description":"Details about the stage activity (provided if type is stage).","properties":{"endTs":{"description":"End timestamp of the stage.","type":"integer"},"identifier":{"description":"Identifier of the stage.","type":"string"},"info":{"$ref":"#/components/schemas/StageInfoDetailsDTO"},"name":{"description":"Name of the stage.","type":"string"},"stageExecutionId":{"description":"Stage execution Id.","type":"string"},"stageNodeId":{"description":"Node Id of the stage.","type":"string"},"startTs":{"description":"Start timestamp of the stage.","type":"integer"},"status":{"$ref":"#/components/schemas/Status"},"type":{"$ref":"#/components/schemas/StageInfoType"}},"required":["type","name","identifier","status","startTs","info"],"type":"object"},"StageInfoDetailsDTO":{"description":"Info related to stage","properties":{"artifactDisplayName":{"description":"Display name of the artifact.","type":"string"},"envId":{"description":"Identifier of the environment.","type":"string"},"envName":{"description":"Name of the environment.","type":"string"},"serviceId":{"description":"Identifier of the service.","type":"string"},"serviceName":{"description":"Name of the service.","type":"string"}},"type":"object"},"Status":{"description":"Status of the stage.","enum":["ABORTED","OUTPUT_WAITING","ASYNC_WAITING","APPROVAL_REJECTED","APPROVAL_WAITING","DISCONTINUING","ERROR","ERRORED","EXPIRED","FAILED","FREEZE_FAILED","IGNORE_FAILED","INPUT_WAITING","INTERVENTION_WAITING","QUEUED","REJECTED","RESUMED","RUNNING","SCHEDULED","SKIPPED","STARTING","STARTING_QUEUED_STEP","SUCCESS","SUCCEEDED","SUSPENDED","TIMED_WAITING","TASK_WAITING","UPLOAD_WAITING","WAIT_STEP_RUNNING","WAITING","ON_HOLD"],"type":"string"},"StageInfoType":{"description":"Type of the stage (e.g., CD, custom)","enum":["CD","Custom","GITOPS","Approval"],"type":"string"},"StepInfoDTO":{"description":"Details about the step activity (provided if type is step).","properties":{"endTs":{"description":"End timestamp of the step.","type":"integer"},"identifier":{"description":"Identifier of the step.","type":"string"},"info":{"$ref":"#/components/schemas/StepInfoDetailsDTO"},"name":{"description":"Name of the step.","type":"string"},"stageExecutionId":{"description":"Stage Execution Id","type":"string"},"stageNodeId":{"description":"Node Id of the stage.","type":"string"},"startTs":{"description":"Start timestamp of the step.","type":"integer"},"status":{"$ref":"#/components/schemas/Status"},"stepExecutionId":{"description":"Step execution identifier.","type":"string"},"type":{"$ref":"#/components/schemas/StepInfoType"}},"required":["type","name","identifier","status","startTs","info"],"type":"object"},"StepInfoDetailsDTO":{"description":"Provided if `type` is Approval.","properties":{"approvalAction":{"description":"Action taken for the approval.","type":"string"},"approvedAt":{"description":"Timestamp of the approval.","format":"integer","type":"integer"},"approvedByEmail":{"description":"Email of the person who approved the step.","type":"string"},"approvedByName":{"description":"Name of the person who approved the step.","type":"string"},"comments":{"description":"Comments provided during the approval.","type":"string"},"issueType":{"description":"Type of the Jira issue.","type":"string"},"jiraUrl":{"description":"URL of the Jira ticket.","type":"string"},"ticketStatus":{"description":"Status of the Jira ticket.","type":"string"}},"type":"object"},"StepInfoType":{"description":"Type of the step (e.g., Approval, JiraUpdate, JiraCreate, JiraApproval).","enum":["HarnessApproval","JiraUpdate","JiraCreate","JiraApproval","ServiceNowApproval","CustomApproval"],"type":"string"},"TriggeredByDTO":{"description":"Details of the user who triggered the activity.","properties":{"avatar":{"description":"Avatar URL of the person.","type":"string"},"email":{"description":"Email of the person who triggered the activity.","type":"string"},"id":{"description":"Identifier of the person who triggered the activity.","type":"string"},"name":{"description":"Name of the person who triggered the activity.","type":"string"},"triggerType":{"$ref":"#/components/schemas/TriggerType"}},"type":"object"},"TriggerType":{"description":"Unit of time used for repeating releases.","enum":["MANUAL","WEBHOOK","WEBHOOK_CUSTOM","ARTIFACT","MANIFEST","SCHEDULER_CRON"],"type":"string"},"ActivityType":{"description":"Type of the activity (e.g., stage, step).","enum":["stage","step"],"type":"string"},"NextRequest":{"properties":{"cursor":{"type":"string"},"limit":{"type":"integer"}},"type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## GET /release/{releaseId}/approvals

> Fetch approvals activity for a release

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}/approvals":{"get":{"operationId":"GetReleaseReleaseIdApprovals","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"},{"$ref":"#/components/parameters/ReleaseId"},{"$ref":"#/components/parameters/SearchTermParam"},{"$ref":"#/components/parameters/StatusListParam"},{"$ref":"#/components/parameters/Page"},{"$ref":"#/components/parameters/Size"},{"$ref":"#/components/parameters/Sort"}],"responses":{"200":{"$ref":"#/components/responses/ReleaseApprovalsResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Fetch approvals activity for a release","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}},"ReleaseId":{"in":"path","name":"releaseId","required":true,"schema":{"type":"string"}},"SearchTermParam":{"description":"Optional search string to filter releases by name.","in":"query","name":"searchTerm","schema":{"type":"string"}},"StatusListParam":{"in":"query","name":"status","schema":{"items":{"type":"string"},"type":"array"}},"Page":{"in":"query","name":"page","schema":{"type":"integer"}},"Size":{"in":"query","name":"size","schema":{"type":"integer"}},"Sort":{"description":"Sort parameters as an array. Format: `[field_name, direction]` where direction is `asc` or `desc`.\nSupported fields: `start_ts`, `startTs`, `end_ts`, `endTs`, `last_updated_at`, `lastUpdatedAt`, `created_at`, `createdAt`, `name`, `identifier`, `status`, `type`.\nWhen used in query params, use format: `sort=field_name&sort=direction` (e.g., `sort=start_ts&sort=desc`).\n","in":"query","name":"sort","schema":{"items":{"type":"string"},"type":"array"}}},"responses":{"ReleaseApprovalsResponse":{"content":{"application/json":{"schema":{"properties":{"content":{"items":{"$ref":"#/components/schemas/ReleaseApprovalDTO"},"type":"array"},"empty":{"type":"boolean"},"first":{"type":"boolean"},"last":{"type":"boolean"},"number":{"type":"integer"},"numberOfElements":{"type":"integer"},"pageable":{"$ref":"#/components/schemas/Pageable"},"size":{"type":"integer"},"sort":{"$ref":"#/components/schemas/PageableSort"},"totalElements":{"type":"integer"},"totalPages":{"type":"integer"}},"required":["content","pageable","totalPages","last","totalElements","size","number","sort","numberOfElements","first","empty"],"type":"object"}}},"description":"Release Approvals Details"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"ReleaseApprovalDTO":{"properties":{"approvalInfo":{"$ref":"#/components/schemas/ApprovalInfoDTO"},"name":{"type":"string"},"nodeExecutionId":{"description":"Node execution ID of the approval step","type":"string"},"orgIdentifier":{"type":"string"},"pipelineIdentifier":{"type":"string"},"pipelineName":{"description":"Human-readable name of the pipeline","type":"string"},"planExecutionId":{"type":"string"},"projectIdentifier":{"type":"string"},"runSequenceId":{"type":"integer"},"status":{"$ref":"#/components/schemas/Status"},"type":{"$ref":"#/components/schemas/ReleaseApprovalType"}},"required":["orgIdentifier","projectIdentifier","pipelineIdentifier","planExecutionId","name","runSequenceId","status","type"],"title":"ReleaseApprovalDTO","type":"object"},"ApprovalInfoDTO":{"properties":{"approvedAt":{"description":"Timestamp of the approval.","format":"int64","type":"integer"},"approvedBy":{"$ref":"#/components/schemas/ApprovedByDTO"},"comments":{"description":"Comments provided during the approval.","type":"string"}},"required":["approvedBy","approvedAt"],"type":"object"},"ApprovedByDTO":{"properties":{"email":{"description":"Email of the person who approved the step.","type":"string"},"name":{"description":"Name of the person who approved the step.","type":"string"}},"required":["email"],"type":"object"},"Status":{"description":"Status of the stage.","enum":["ABORTED","OUTPUT_WAITING","ASYNC_WAITING","APPROVAL_REJECTED","APPROVAL_WAITING","DISCONTINUING","ERROR","ERRORED","EXPIRED","FAILED","FREEZE_FAILED","IGNORE_FAILED","INPUT_WAITING","INTERVENTION_WAITING","QUEUED","REJECTED","RESUMED","RUNNING","SCHEDULED","SKIPPED","STARTING","STARTING_QUEUED_STEP","SUCCESS","SUCCEEDED","SUSPENDED","TIMED_WAITING","TASK_WAITING","UPLOAD_WAITING","WAIT_STEP_RUNNING","WAITING","ON_HOLD"],"type":"string"},"ReleaseApprovalType":{"description":"Type of the step (e.g., Approval, JiraUpdate, JiraCreate, JiraApproval).","enum":["HarnessApproval","JiraApproval","ServiceNowApproval","CustomApproval"],"type":"string"},"Pageable":{"properties":{"offset":{"type":"integer"},"pageNumber":{"type":"integer"},"pageSize":{"type":"integer"},"paged":{"type":"boolean"},"sort":{"$ref":"#/components/schemas/PageableSort"},"unpaged":{"type":"boolean"}},"type":"object"},"PageableSort":{"properties":{"empty":{"type":"boolean"},"sorted":{"type":"boolean"},"unsorted":{"type":"boolean"}},"type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## Environment Dashbaord for a release

> Gets the environment dashboard for the given release

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}/environmentDashboard":{"get":{"description":"Gets the environment dashboard for the given release","operationId":"GetReleaseReleaseIdEnvironmentDashboard","parameters":[{"$ref":"#/components/parameters/AccountParam"}],"responses":{"200":{"$ref":"#/components/responses/EnvironmentDashboardResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"401":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Environment Dashbaord for a release","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}}},"responses":{"EnvironmentDashboardResponse":{"content":{"application/json":{"schema":{"properties":{"environments":{"items":{"$ref":"#/components/schemas/EnvironmentDashboardDTO"},"type":"array"}},"required":["environments"],"type":"object"}}},"description":"Response for the environment dashboard screen"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"EnvironmentDashboardDTO":{"properties":{"clusters":{"description":"List of GitOps cluster deployments with their services","items":{"$ref":"#/components/schemas/ClusterDeploymentDTO"},"type":"array"},"identifier":{"type":"string"},"infraInfo":{"deprecated":true,"description":"DEPRECATED: Use infrastructures and clusters arrays instead for complete deployment information","properties":{"identifier":{"type":"string"},"name":{"type":"string"}},"required":["name","identifier"],"type":"object"},"infrastructures":{"description":"List of traditional infrastructure deployments with their services","items":{"$ref":"#/components/schemas/InfrastructureDeploymentDTO"},"type":"array"},"name":{"type":"string"},"orgIdentifier":{"description":"Organization identifier of Environment","type":"string"},"projectIdentifier":{"description":"Project identifier of Environment","type":"string"},"scope":{"default":"account","enum":["account","project","org","unknown"],"type":"string"},"serviceInfo":{"deprecated":true,"description":"DEPRECATED: Use infrastructures and clusters arrays instead for complete deployment information","items":{"$ref":"#/components/schemas/ServiceInfoDTO"},"type":"array"},"type":{"$ref":"#/components/schemas/EnvironmentType"}},"required":["name","identifier","serviceInfo","type","infraInfo","scope"],"title":"EnvironmentDashboardDTO","type":"object"},"ClusterDeploymentDTO":{"description":"Represents services deployed to a GitOps cluster","properties":{"agentIdentifier":{"description":"GitOps agent identifier","type":"string"},"clusterIdentifier":{"description":"Cluster identifier","type":"string"},"infraIdentifier":{"description":"Optional infrastructure identifier (if cluster is mapped to infra)","type":"string"},"infraName":{"description":"Optional infrastructure name (if cluster is mapped to infra)","type":"string"},"services":{"description":"Services deployed to this cluster","items":{"$ref":"#/components/schemas/ServiceInfoDTO"},"type":"array"}},"required":["clusterIdentifier","agentIdentifier","services"],"title":"ClusterDeploymentDTO","type":"object"},"ServiceInfoDTO":{"description":"Holds the information of a given service along with its artifact version","properties":{"artifactVersion":{"type":"string"},"identifier":{"type":"string"},"name":{"type":"string"},"orgIdentifier":{"type":"string"},"projectIdentifier":{"type":"string"},"scope":{"default":"account","enum":["account","project","org","unknown"],"type":"string"}},"required":["name","identifier","scope"],"title":"ServiceInfoDto","type":"object"},"InfrastructureDeploymentDTO":{"description":"Represents services deployed to a traditional infrastructure","properties":{"identifier":{"description":"Infrastructure identifier","type":"string"},"name":{"description":"Infrastructure name","type":"string"},"services":{"description":"Services deployed to this infrastructure","items":{"$ref":"#/components/schemas/ServiceInfoDTO"},"type":"array"}},"required":["identifier","name","services"],"title":"InfrastructureDeploymentDTO","type":"object"},"EnvironmentType":{"enum":["PreProduction","Production"],"type":"string"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## Fetch the list of environments for release

> Api to fetch the list of environments for release

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}/environments":{"get":{"description":"Api to fetch the list of environments for release","operationId":"GetReleaseReleaseIdEnvironments","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"description":"Next token for fetching the environment","in":"query","name":"cursor","schema":{"type":"string"}},{"$ref":"#/components/parameters/Limit"},{"description":"Optional variable to filter environments based on the given prefix","in":"query","name":"searchTerm","schema":{"type":"string"}}],"responses":{"200":{"$ref":"#/components/responses/EnvironmentListPerReleaseResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"401":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Fetch the list of environments for release","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"Limit":{"description":"The number of records expected","in":"query","name":"limit","schema":{"default":500,"maximum":500,"type":"number"}}},"responses":{"EnvironmentListPerReleaseResponse":{"content":{"application/json":{"schema":{"properties":{"environments":{"items":{"$ref":"#/components/schemas/EnvironmentDTO"},"type":"array"},"last":{"type":"boolean"},"nextRequest":{"$ref":"#/components/schemas/NextRequest"}},"required":["environments","last"],"type":"object"}}},"description":""},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"EnvironmentDTO":{"properties":{"identifier":{"type":"string"},"orgIdentifier":{"type":"string"},"projectIdentifier":{"type":"string"}},"required":["identifier"],"title":"EnvironmentDTO","type":"object"},"NextRequest":{"properties":{"cursor":{"type":"string"},"limit":{"type":"integer"}},"type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```

## Trigger Subprocess from Task

> Triggers a subprocess release from a task within the specified release

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}/subprocess/trigger":{"post":{"description":"Triggers a subprocess release from a task within the specified release","operationId":"PostReleaseSubprocessTrigger","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"},{"description":"The user_reference_id of the task that triggers the subprocess","in":"query","name":"task_id","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SubprocessTriggerRequest"}}},"required":true},"responses":{"200":{"$ref":"#/components/responses/SubprocessTriggerResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Trigger Subprocess from Task","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}}},"schemas":{"SubprocessTriggerRequest":{"properties":{"subprocessInfo":{"$ref":"#/components/schemas/SubprocessInfo"}},"required":["subprocessInfo"],"title":"SubprocessTriggerRequest","type":"object"},"SubprocessInfo":{"properties":{"output":{"additionalProperties":{"type":"string"},"description":"Output map with key-value pairs.","type":"object"},"processIdentifier":{"description":"Process identifier. Required when retryWith is SUBPROCESS.","type":"string"},"processInputIdentifier":{"description":"Process input identifier. Required when retryWith is SUBPROCESS.","type":"string"},"releaseInput":{"description":"Release input YAML. Required when retryWith is SUBPROCESS.","type":"string"}},"required":["processIdentifier","processInputIdentifier","releaseInput","output"],"type":"object"},"SubprocessTriggerResponse":{"properties":{"activityExecutionId":{"description":"ID of the newly created activity execution","type":"string"}},"required":["activityExecutionId"],"type":"object"},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}},"responses":{"SubprocessTriggerResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SubprocessTriggerResponse"}}},"description":"Response of subprocess trigger API"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}}}}
```

## Fetch Release Tasks

> Fetch a paginated list of tasks from Manual Activities for a release with cursor-based pagination and optional status filtering.

```json
{"openapi":"3.0.0","info":{"title":"rms","version":"1.0"},"tags":[{"name":"Releases"}],"servers":[{"url":"/api"}],"paths":{"/release/{releaseId}/tasks":{"get":{"description":"Fetch a paginated list of tasks from Manual Activities for a release with cursor-based pagination and optional status filtering.","operationId":"GetReleaseTasks","parameters":[{"$ref":"#/components/parameters/AccountParam"},{"$ref":"#/components/parameters/OrgParam"},{"$ref":"#/components/parameters/ProjectParam"},{"description":"Release ID","in":"path","name":"releaseId","required":true,"schema":{"type":"string"}},{"$ref":"#/components/parameters/Cursor"},{"$ref":"#/components/parameters/Limit"},{"description":"Filter tasks by status (TODO, IN_PROGRESS, SUCCEEDED, FAILED, BLOCKED)","in":"query","name":"status","schema":{"items":{"description":"Current status of the execution task","enum":["TODO","IN_PROGRESS","SUCCEEDED","FAILED","BLOCKED"],"type":"string"},"type":"array"}}],"responses":{"200":{"$ref":"#/components/responses/ReleaseTasksResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"},"500":{"$ref":"#/components/responses/ErrorResponse"}},"summary":"Fetch Release Tasks","tags":["Releases"]}}},"components":{"parameters":{"AccountParam":{"description":"Account Identifier","in":"header","name":"Harness-Account","required":true,"schema":{"type":"string"}},"OrgParam":{"description":"Organisation Identifier","in":"query","name":"orgIdentifier","schema":{"type":"string"}},"ProjectParam":{"description":"Project Identifier","in":"query","name":"projectIdentifier","schema":{"type":"string"}},"Cursor":{"description":"Cursor Based Pagination","in":"query","name":"cursor","schema":{"type":"string"}},"Limit":{"description":"The number of records expected","in":"query","name":"limit","schema":{"default":500,"maximum":500,"type":"number"}}},"responses":{"ReleaseTasksResponse":{"content":{"application/json":{"schema":{"properties":{"last":{"description":"Whether this is the last page of results","type":"boolean"},"nextRequest":{"$ref":"#/components/schemas/NextRequest"},"tasks":{"description":"List of tasks from manual activities.","items":{"$ref":"#/components/schemas/ExecutionTaskDTO"},"type":"array"}},"required":["tasks","nextRequest","last"],"type":"object"}}},"description":"Successful response for release tasks"},"ErrorResponse":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Error Response body"}},"schemas":{"NextRequest":{"properties":{"cursor":{"type":"string"},"limit":{"type":"integer"}},"type":"object"},"ExecutionTaskDTO":{"description":"Represents an execution task for a specific activity","properties":{"actualDuration":{"description":"Actual duration taken for the task (e.g., \"7h\")","type":"string"},"createdAt":{"description":"Unix timestamp when the task was created","format":"int64","type":"integer"},"description":{"description":"Description of the task","type":"string"},"execute":{"$ref":"#/components/schemas/TaskExecuteConfig"},"expectedDuration":{"description":"Expected duration for the task (e.g., \"1d 12h\")","type":"string"},"failureInfo":{"$ref":"#/components/schemas/FailureInfo"},"identifier":{"description":"Unique identifier of the task","type":"string"},"lastUpdatedAt":{"description":"Unix timestamp when the task was last updated","format":"int64","type":"integer"},"name":{"description":"Name of the task","type":"string"},"required":{"$ref":"#/components/schemas/StringOrBool"},"status":{"$ref":"#/components/schemas/ExecutionTaskStatus"},"taskExecutionId":{"description":"ID of the task execution","type":"string"},"userGroups":{"$ref":"#/components/schemas/StringOrStringArray"}},"required":["identifier","name","status","required","userGroups","expectedDuration"],"type":"object"},"TaskExecuteConfig":{"description":"Configuration for subprocess execution from a manual task","properties":{"processes":{"description":"Either the literal string \"all\" (any process can be triggered), the literal string \"none\" (no process can be triggered), or an array of whitelisted process identifiers.\n","oneOf":[{"enum":["all","none"],"type":"string"},{"items":{"type":"string"},"type":"array"}]}},"required":["processes"],"type":"object"},"FailureInfo":{"description":"Information about a failure that occurred","properties":{"code":{"description":"The failure code indicating the type of failure","type":"string"},"msg":{"description":"The failure message describing what went wrong","type":"string"}},"required":["msg"],"type":"object"},"StringOrBool":{"description":"Flexible type that accepts either a boolean or a string","oneOf":[{"description":"Boolean value","type":"boolean"},{"description":"String value","type":"string"}]},"ExecutionTaskStatus":{"description":"Current status of the execution task","enum":["TODO","IN_PROGRESS","SUCCEEDED","FAILED","BLOCKED"],"type":"string"},"StringOrStringArray":{"description":"Flexible type that accepts either a single string or an array of strings for user references","oneOf":[{"description":"Reference as a string","type":"string"},{"description":"Array of references as strings","items":{"type":"string"},"type":"array"}]},"Error":{"description":"Error Response","properties":{"code":{"description":"canonical error code name","enum":["BAD_REQUEST","UNAUTHORIZED","FORBIDDEN","NOT_FOUND","INTERNAL_SERVER_ERROR"],"type":"string"},"explanation":{"description":"additional context about why the error occurred","type":"string"},"governanceMetadata":{"$ref":"#/components/schemas/GovernanceMetadata"},"message":{"description":"error message detail","type":"string"},"probable_fixes":{"description":"suggested actions to resolve the error","items":{"type":"string"},"type":"array"}},"required":["message"],"title":"Error Response","type":"object"},"GovernanceMetadata":{"properties":{"accountId":{"type":"string"},"action":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"details":{"items":{"$ref":"#/components/schemas/PolicySetMetadata"},"type":"array"},"entity":{"type":"string"},"id":{"type":"string"},"message":{"type":"string"},"orgId":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"type":"object"},"PolicySetMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"deny":{"type":"boolean"},"description":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyMetadata":{"items":{"$ref":"#/components/schemas/PolicyMetadata"},"type":"array"},"policySetId":{"type":"string"},"policySetName":{"type":"string"},"projectId":{"type":"string"},"status":{"type":"string"}},"type":"object"},"PolicyMetadata":{"properties":{"accountId":{"type":"string"},"created":{"type":"string"},"denyMessages":{"items":{"type":"string"},"type":"array"},"error":{"type":"string"},"identifier":{"type":"string"},"orgId":{"type":"string"},"policyId":{"type":"string"},"policyName":{"type":"string"},"projectId":{"type":"string"},"severity":{"type":"string"},"status":{"type":"string"},"updated":{"type":"string"}},"type":"object"}}}}
```
